package commons.pfc;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.BitmapFactory;
import android.graphics.BitmapFactory.Options;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;

public class Info_Imagen_BD extends Activity {

	 ImageView imgPhoto;
	 Bitmap aux;
	 private static String path_aux;
	 
	 @Override
	public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
	        setContentView(R.layout.layout_info_imagen_bd);
	        try {
				Inicializar();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	 }
	 
	 private void Inicializar() throws IOException
	 {		 
		 TextView textnombre = (TextView) findViewById(R.id.edit_nombre);
		 TextView textdescripcion = (TextView) findViewById(R.id.edit_descripcion);
		 TextView textfecha = (TextView) findViewById(R.id.edit_fecha);
		 imgPhoto = (ImageView) findViewById(R.id.imgaen_imagen_bd);
		 
		 Bundle extra = this.getIntent().getExtras();
		 
		 String descripcion = extra.getString("descripcion_imagen");
		 String nombre = extra.getString("nombre_imagen");
		 String uri = extra.getString("uri_imagen");
		 String fecha = extra.getString("fecha_imagen");
		 String path = extra.getString("path_imagen");
		 copyFile(path, Environment.getExternalStorageDirectory().toString());
		 
		 
		 try {
			 if(aux != null)
		         	aux.recycle();
		         aux = null;
		         
			 aux = BitmapFactory.decodeFile(path_aux);
			 
			} catch (OutOfMemoryError e) {
			  try {
			    Options options = new BitmapFactory.Options();
			    options.inSampleSize = 2;
			    aux = BitmapFactory.decodeFile(path_aux, options);
			   
			  } catch(Exception ex) {
			    Log.e(path, path, e);
			  }
			}
		 
		 
		 
		 FileOutputStream out;
		 
		 if (aux != null)
		 {
		     try 
		     {
		    	 
		    	   out = new FileOutputStream(path_aux);
		    	   aux.compress(CompressFormat.JPEG, 60, out);
		    	   imgPhoto.setImageBitmap(aux);
		     }
		     catch (FileNotFoundException e) 
		     {
		        Intent intent = new Intent();
		  		intent.setComponent(new ComponentName(this, mapa_monumentos_DB.class));
		  		startActivity(intent);
		     }
		     textnombre.setText(nombre);
			 textdescripcion.setText(descripcion);
			 textfecha.setText(fecha);
		 }
		 else
		 { 
			 TextView tv = (TextView) findViewById(R.id.titulo_descripcion_imagen_bd);
			 TextView tv1 = (TextView) findViewById(R.id.titulo_nombre_imagen_bd);
			 TextView tv2 = (TextView) findViewById(R.id.titulo_fecha_imagen_bd);
			 textdescripcion.setText("");
			 textfecha.setText("");
			 tv.setText("");
			 tv1.setText("");
			 tv2.setText("");
			 textnombre.setText("Imagen eliminada del telfono"); 
		}
	 }
	 
	@Override
    public void onBackPressed()
	{
	 Intent intent = new Intent();
	 Reset_ImageView();
	 intent.setComponent(new ComponentName(this, mapa_monumentos_DB.class));
	 startActivity(intent);
    }
	
	 private void Reset_ImageView()
	    {
	    	if (imgPhoto != null) 
	    	{
	        	imgPhoto.destroyDrawingCache();
	        	imgPhoto.setImageBitmap(null);
	        	imgPhoto = null;
	            System.gc();
	            if(aux != null)
	            	aux.recycle();
	            aux = null;
	        }
	    }
	 
	 public static boolean copyFile(String from, String to) throws IOException {    
         File sd = Environment.getExternalStorageDirectory();
         if (sd.canWrite()) {
             int end = from.toString().lastIndexOf("/");
             String str1 = from.toString().substring(0, end);
             String str2 = from.toString().substring(end+1, from.length());
             File source = new File(str1, str2);
             File destination= new File(to, str2);
             if (source.exists()) {
                 FileChannel src = new FileInputStream(source).getChannel();
                 FileChannel dst = new FileOutputStream(destination).getChannel();
                 dst.transferFrom(src, 0, src.size());
                 src.close();
                 dst.close();
                 
                 path_aux = destination.getPath();
             }
         }
         return true;
     } 
}
