package commons.pfc;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.drawable.Drawable;
import android.os.Bundle;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class mapa_monumentos_DB extends MapActivity{
	
	 private Vector<String> info_toast = new Vector<String>();
     private MapView mapView;
     private MapController myMapController;
     private List<Overlay> mOverlays;
     private MyLocationOverlay mOverlayLocation;
     private aux x = new aux();//Clase puente para utilizar los datos	
     Intent intent = new Intent();

	 @Override
	 public void onCreate(Bundle savedInstanceState) {
         super.onCreate(savedInstanceState);
         setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
         setContentView(R.layout.layout_mapa_db);
         
         mapView = (MapView) findViewById(R.id.mapview);
         myMapController = mapView.getController();
         mOverlays = mapView.getOverlays();
         mOverlayLocation = new MyLocationOverlay(this, mapView);
         
         if(AndromediacommonsActivity.database == null)
        	 AndromediacommonsActivity.database = new monumentsDB(this);
         
         if(AndromediacommonsActivity.database.num_monumentos()>0 )
         {
        	
        	 AndromediacommonsActivity.datos_monumentos_bd =  AndromediacommonsActivity.database.ObtenerMonumentos();
        	 
        	
        	 //Canvas c = 
        	 Monumentos_Overlay capas_monumentos = new Monumentos_Overlay(getResources().getDrawable(R.drawable.ico_monumento), this);
             GeoPoint centro = new GeoPoint((int)(Float.parseFloat(AndromediacommonsActivity.datos.latitud) * 1E6), (int)(Float.parseFloat(AndromediacommonsActivity.datos.longitud) * 1E6));
             myMapController.setCenter(centro);
             myMapController.setZoom(18);
             mOverlayLocation.enableMyLocation();
             mOverlayLocation.enableCompass();

             for(int i=0; i < AndromediacommonsActivity.datos_monumentos_bd.size(); ++i)
             {
             	capas_monumentos.addMonumentos(AndromediacommonsActivity.datos_monumentos_bd.get(i).latitud+ "XXX" + AndromediacommonsActivity.datos_monumentos_bd.get(i).longitud+ "XXX" + AndromediacommonsActivity.datos_monumentos_bd.get(i).nom_imagen+ "XXX" +AndromediacommonsActivity.datos_monumentos_bd.get(i).descripcion_corta+ "XXX" +AndromediacommonsActivity.datos_monumentos_bd.get(i).uri + "XXX" +AndromediacommonsActivity.datos_monumentos_bd.get(i).fecha + "XXX" + AndromediacommonsActivity.datos_monumentos_bd.get(i).path);
             	
				/* Drawable d = Drawable.createFromPath("");
             	capas_monumentos.mOverlays.add(mapView.setBackgroundDrawable(d));*/
             	
             }
            
             mOverlays.add(mOverlayLocation);
             mOverlays.add(capas_monumentos);
             mapView.postInvalidate();
             
             
         }
         else
         {
        	 if(!AndromediacommonsActivity.datos.wikimonuments)
        	 {
	        	 AndromediacommonsActivity.datos.exist_db = false;
	        	 Intent intent = new Intent();
	        	 intent.setComponent(new ComponentName(this, mensaje_campos_obligatorios.class));
	    		 startActivity(intent);
        	 }
         }  	
	 }


	@Override
	protected boolean isRouteDisplayed() {
             return false;
         }
         
         public class Monumentos_Overlay extends ItemizedOverlay<OverlayItem> {
             
             private List<OverlayItem> mOverlays;
             private Context mContext;
             
             public Monumentos_Overlay(Drawable icon, Context context) {
                 super(boundCenter(icon));
                 mOverlays = new ArrayList<OverlayItem>();
                 mContext = context;
             }

             @Override
             protected OverlayItem createItem(int index) {
                 return mOverlays.get(index);
             }

             @Override
             public int size() { return mOverlays.size();}

             public void addOverlay(OverlayItem overlay) {

                 mOverlays.add(overlay);
                 populate();
             }

             public void addMonumentos(String datos_monumento) {
             	String[]monumento = datos_monumento.split("XXX");
             	
             	if (!datos_monumento.contains("XXXXXXX"))
             	{
	                 String latt = monumento[0].toString();
	                 String lonn = monumento[1].toString();
	                 String nombre = monumento[2];
	                 String descripcion = monumento[3];
	                 String uris = monumento[4];
	                 String fecha = monumento[5];
	                 String path = monumento[6];
	                 float lat=0, lon=0;
	                 if (latt.length() != 0 && lonn.length() != 0)
	                 {
	                	 if (latt.length() > 7)
	                		 latt = latt.substring(0,7);
	                	 if (lonn.length() > 7)
	                		 lonn = lonn.substring(0,7);
	                 
	                	 lat = Float.parseFloat(latt);
	                	 lon= Float.parseFloat(lonn);
	                 
	                	 GeoPoint point = new GeoPoint((int)(lat * 1E6), (int)(lon * 1E6));
	                	 OverlayItem item_monumento = new OverlayItem(point, "Monumento", nombre);
	                	 addOverlay(item_monumento);
	         
	                 	info_toast.add(nombre + "XXX" + descripcion + "XXX" + uris+ "XXX" + fecha + "XXX" + latt + "XXX" + lonn + "XXX" +path);
	                 }
             	}
             }
             
             @Override
             protected final boolean onTap(int index) 
             {
            	
            	 cual_mostrar(index);
                 
                 return true;
             }
         }
         
         private void cual_mostrar(int index)
         {
        	 String[] valores_pasar = info_toast.get(index).split("XXX");
         	 
        	 intent.putExtra("nombre_imagen", valores_pasar[0]);
        	 intent.putExtra("descripcion_imagen", valores_pasar[1]);
        	 intent.putExtra("uri_imagen", valores_pasar[2]);
        	 intent.putExtra("fecha_imagen", valores_pasar[3]);
        	 intent.putExtra("lat_imagen", valores_pasar[4]);
        	 intent.putExtra("lon_imagen", valores_pasar[5]);
        	 intent.putExtra("path_imagen", valores_pasar[6]);
         	
        	 intent.setComponent(new ComponentName(this, Info_Imagen_BD.class));
             startActivity(intent);
        	 
         }
         public class aux extends AndromediacommonsActivity
         {
         	//Clase que hace de puente entre AndromediacommonsActivity y mapa monumentos, ya que esta ltima herede de mapactivity y necesito acceder a los datos
         	//de andromedia commonsactivity para ver monumentos y dems datos.
         	//Con esta clase me ahorro de replicar metodos y por lo tanto tambien codigo y el coste de tiempo y consumo de datos asociado a ello,
         }
         
         @Override
 	    public void onBackPressed()
 	    {
        	monumentsDB.bd = false;
 			Intent intent = new Intent();
 			intent.setComponent(new ComponentName(this, modo_captura.class));
 			startActivity(intent);
 	    }
}
